
from ricci_defines import *


## request vars ##

PAGETYPE="pagetype"
CLUNAME="clustername"
STONAME='storagename'



## pagetypes ##

# CLUSTER PAGE_TYPEs #
CLUSTERS="4"
CLUSTER="5"
CLUSTER_ADD="6"
CLUSTER_CONFIG="7"
NODE="9"
NODES="10"
NODE_LIST="11"
NODE_GRID="12"
NODE_CONFIG="14"
NODE_ADD="15"
NODE_PROCESS="16"
SERVICES="20"
SERVICE_ADD="21"
SERVICE_LIST="22"
SERVICE_CONFIG="23"
SERVICE="24"
SERVICE_PROCESS="25"
RESOURCES="30"
RESOURCE_ADD="31"
RESOURCE_LIST="32"
RESOURCE_CONFIG="33"
RESOURCE="34"
RESOURCE_PROCESS="35"
FDOMS="40"
FDOM_ADD="41"
FDOM_LIST="42"
FDOM_CONFIG="43"
FDOM="44"
FENCEDEVS="50"
FENCEDEV_ADD="51"
FENCEDEV_LIST="52"
FENCEDEV_CONFIG="53"
FENCEDEV="54"


# storage pagetypes #

PT_MAPPER_ID='mapper_id'
PT_MAPPER_TYPE='mapper_type'
PT_PATH='bd_path'

STORAGESYS="0"
STORAGE_CONFIG="43"
STORAGE="44"
CLUSTER_STORAGE="45"

STORAGE_COMMIT_CHANGES='commit_changes'


VIEW_MAPPERS = '51'
VIEW_MAPPER = '52'

VIEW_BDS = '61'
VIEW_BD = '62'


CREATE_MAPPER = '101'
ADD_SOURCES   = '102'



# pretty names

PRETTY_MAPPER_INFO = {MAPPER_SYS_TYPE         : ('Hard Drives',     'Hard Drive',     'BUG: source not defined'),
                      MAPPER_VG_TYPE          : ('Volume Group',    'Logical Volume', 'Physical Volume'),
                      MAPPER_PT_TYPE          : ('Partition Table', 'Partition',      'Disk'),
                      MAPPER_MDRAID_TYPE      : ('Software RAID',   'Volume',         'Disk'),
                      MAPPER_ATARAID_TYPE     : ('ATA-RAID',        'Volume',         'Disk'),
                      MAPPER_MULTIPATH_TYPE   : ('Multipath',       'Multipath',      'Path'),
                      MAPPER_CRYPTO_TYPE      : ('Encryption',      'Volume',         'Device'),
                      MAPPER_iSCSI_TYPE       : ('iSCSI',           'Volume',         'BUG: source not defined')}
def get_pretty_mapper_info(mapper_type):
    try:
        return PRETTY_MAPPER_INFO[mapper_type]
    except:
        return ('Mapper ' + mapper_type, mapper_type + '\s target', mapper_type + '\s source')

PRETTY_PROP_NAMES = {'active'                  : "Active",
                     'attrs'                   : 'Attributes',
                     'bd'                      : "Block Device",
                     'block_count'             : "Number of Blocks",
                     'block_size'              : "Block Size",
                     'bootable'                : "Bootable",
                     'cluster_name'            : "Cluster Name",
                     'clustered'               : "Clustered",
                     'dir_index'               : "Use Hashed Binary Trees",
                     'disklabel'               : "Partition Table Type",
                     'extents_free'            : "Free Extents",
                     'extent_size'             : "Extent Size",
                     'extents_total'           : "Total Extents",
                     'extents_used'            : "Used Extents",
                     'failed'                  : "Failed",
                     'format'                  : "Format",
                     'fstab'                   : "List in /etc/fstab", 
                     'fstabpoint'              : "/etc/fstab Mountpoint", 
                     'gfs_fsname'              : "Unique GFS Name", 
                     'has_journal'             : "Journaling Enabled - ext3",
                     'journals_num'            : "Number Of Journals", 
                     'journal_size'            : "Journal Size", 
                     'label'                   : "Label",
                     'level'                   : "Level",
                     'locking_protocol'        : "Locking Protocol",
                     'lvname'                  : "Logical Volume Name",
                     'max_lvs'                 : "Maximum Logical Volumes",
                     'max_pvs'                 : "Maximum Physical Volumes",
                     'max_sources'             : "Maximum Disks",
                     'min_sources'             : "Minimum Disks",
                     'mirrored'                : "Mirrored",
                     'model'                   : "Model",
                     'mount'                   : "Mount",
                     'mountable'               : "Mountable",
                     'mountpoint'              : "Mountpoint", 
                     'num_devices'             : "Number of Devices",
                     'num_spares'              : "Number of Spares",
                     'partition_begin'         : "Partition Begin",
                     'partition_num'           : "Partition Number",
                     'partition_type'          : "Partition Type",
                     'path'                    : "Path",
                     'raid'                    : "Raid",
                     'raid_level'              : "Raid Level",
                     'removable'               : "Removable",
                     'scsi_bus'                : "SCSI Address",
                     'scsi_id'                 : "SCSI ID",
                     'size'                    : "Size",
                     'size_free'               : "Unused",
                     'snapshot'                : "Snapshot",
                     'snapshot_origin'         : "Snapshot Origin",
                     'snapshots'               : "Snapshots",
                     'snapshot_usage_percent'  : "Snapshot Usage",
                     'state'                   : "State",
                     'swapon'                  : "Active Swap",
                     'type'                    : "Type",
                     'uuid'                    : "UUID",
                     'vendor'                  : "Vendor",
                     'vgname'                  : "Volume Group Name"}
def get_pretty_prop_name(name):
    try:
        return PRETTY_PROP_NAMES[name]
    except:
        return name

PRETTY_FS_NAMES = {'ext'      : "Linux Extended FS",
                   'swap'     : "Swap",
                   'gfs1'     : "GFS1 - Global FS v.1",
                   'gfs2'     : "GFS2 - Global FS v.2",
                   'minix'    : "Minix FS",
                   'ufs'      : "Unix Fast FS",
                   'xfs'      : "SGI XFS",
                   'isofs'    : "ISO 9660 CD-ROM FS",
                   'cramfs'   : "Cram FS",
                   'raiserfs' : "Reiser FS",
                   'jffs'     : "Journalled Flash FS v.1",
                   'jffs2'    : "Journalled Flash FS v.2",
                   'squashfs' : "Squash FS",
                   'vfat'     : "MS vfat FS",
                   'msdos'    : "MS-DOS FS",
                   'affs'     : "Amiga FS",
                   'befs'     : "BeOS FS",
                   'bfs'      : "SCO UnixWare BFS",
                   'jfs'      : "Journaled Filesystem (JFS)",
                   'efs'      : "efs",
                   'freevxfs' : "Veritas Filesystem (VxFS)",
                   'hfsplus'  : "Macintosh extended FS",
                   'hfs'      : "Macintosh FS",
                   'ncpfs'    : "ncpfs",
                   'ocfs2'    : "Oracle Clustered FS v.2",
                   'relayfs'  : "Relay FS",
                   'udf'      : "Universal Disk Format"}
def get_pretty_fs_name(name):
    try:
        return PRETTY_FS_NAMES[name]
    except:
        return name




# icons

MAPPER_ICONS = {MAPPER_SYS_TYPE         : ('',                          'icon_bd_ide.png',       ''),
                MAPPER_VG_TYPE          : ('icon_mapper_VG.png',        'icon_bd_LV.png',        'icon_content_PV.png'),
                MAPPER_PT_TYPE          : ('icon_mapper_PT.png',        'icon_bd_partition.png', ''),
                MAPPER_MDRAID_TYPE      : ('icon_mapper_raid.png',      'icon_bd_raid.png',      ''),
                MAPPER_ATARAID_TYPE     : ('icon_mapper_raid.png',      'icon_bd_raid.png',      ''),
                MAPPER_MULTIPATH_TYPE   : ('icon_mapper_multipath.png', 'icon_bd_multipath.png', ''),
                MAPPER_CRYPTO_TYPE      : ('icon_mapper_crypto.png',    'icon_bd_crypto.png',    ''),
                MAPPER_iSCSI_TYPE       : ('',                          'icon_bd_net.png',       '')}
def get_mapper_icons(mapper_type):
    try:
        return MAPPER_ICONS[mapper_type]
    except:
        return ('', '', '')


def get_fs_icon(fstype):
    # all fss have the same icon
    return 'icon_content_FS.png'
